package com.ruoyi.job.task;

import com.ruoyi.common.core.constant.TdEngineConstants;
import com.ruoyi.tdengine.api.RemoteTdEngineService;
import com.ruoyi.tdengine.api.domain.DeviceStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;
import com.ruoyi.common.core.utils.StringUtils;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * 定时任务调度测试
 *
 * @author ruoyi
 */
@Component("ryTask")
public class RyTask {
    @Resource
    private RemoteTdEngineService remoteTdEngineService;

    @Autowired
    private StringRedisTemplate redisTemplate;


    public void ryMultipleParams(String s, Boolean b, Long l, Double d, Integer i) {
        System.out.println(StringUtils.format("执行多参方法： 字符串类型{}，布尔类型{}，长整型{}，浮点型{}，整形{}", s, b, l, d, i));
    }

    public void ryParams(String params) {
        System.out.println("执行有参方法：" + params);
    }

    public void ryNoParams() {
        System.out.println("执行无参方法");
    }


    public void updateDeviceStatusData(Long days) {
        Long startTime = 0L;//先是昨天
        Long endTime = 1L;
        DeviceStatus queryGroupStatus = new DeviceStatus();
        queryGroupStatus.setStartTime(startTime);
        queryGroupStatus.setEndTime(endTime);

        DeviceStatus queryLastStatus = new DeviceStatus();
        queryLastStatus.setEndTime(startTime);


        Map<Long, List<DeviceStatus>> groupDeviceStatuMapList =
                (Map<Long, List<DeviceStatus>>) this.remoteTdEngineService.getOnlineDevicesGroupByDay(queryGroupStatus).getData();
        List<Map<String, Object>> lastDeviceStatuMapList =
                (List<Map<String, Object>>) this.remoteTdEngineService.getLastOnlineDevices(queryLastStatus).getData();
        for (Map<String, Object> groupDeviceStatuMap : lastDeviceStatuMapList) {
            DeviceStatus ds = new DeviceStatus();
            for (Map.Entry<String, Object> entry : groupDeviceStatuMap.entrySet()) {
                if (entry.getKey().equals(TdEngineConstants.ST_TAG_DEVICEID)) {
                    ds.setDeviceId((Long) entry.getValue());
                } else if (entry.getKey().equals(TdEngineConstants.ST_TAG_DEVICETYPE)) {
                    ds.setDeviceType((Integer) entry.getValue());
                } else if (entry.getKey().equals(TdEngineConstants.ST_TAG_ONLINESTATUS)) {
                    ds.setOnlineStatus((Integer) entry.getValue());
                }
            }

            if(groupDeviceStatuMapList.get(ds.getDeviceId())==null){
//                groupDeviceStatuMapList.put(ds.getDeviceId(), Lists.newArrayList());
            }

        }

    }
}
